# Bruch-einfachere-Addition.py
class Bruch:
    def __init__(self, zaehler, nenner):
        self.zaehler=zaehler
        self.nenner=nenner

    def zeige(self):
        print( "(", self.zaehler, "/" , self.nenner, ")" )

    def gib(self):
        return self.zaehler, self.nenner

    def gibString(self):
        return str(self.zaehler)+  " / " + str(self.nenner)

    def multipliziere(self, b):
        temp=Bruch(self.zaehler*b.zaehler, self.nenner*b.nenner)
        temp.kuerze()
        return temp
    
    def dividiere(self, b):
        if b.zaehler!=0:
            temp=Bruch(self.zaehler*b.nenner, self.nenner*b.zaehler)
            temp.kuerze()
        else: temp=self
        return temp

    def kuerze(self):
        # zaehler kann 0 sein:
        if self.zaehler==0: self.nenner=1
        else:
            # zaehler kann negativ sein!
            teiler=ggT(abs(self.zaehler),self.nenner)
            self.zaehler=self.zaehler//teiler
            self.nenner=self.nenner//teiler
        
    # gleichnamig ist nur ein Problem ohne Langzahlarithmetik
    def addiere(self, b):
        temp=Bruch(self.zaehler*b.nenner+b.zaehler*self.nenner,self.nenner*b.nenner)
        temp.kuerze()
        return temp
    
    def subtrahiere(self, b):
        temp=Bruch(self.zaehler*b.nenner-b.zaehler*self.nenner,self.nenner*b.nenner)
        temp.kuerze()
        return temp
        
# Klassenunabhaengige Funktionen
def ggT(a, b):
    if a<b: a,b=b,a
    rest=a%b
    while rest>0:
        a=b
        b=rest
        rest=a%b
    return b


# ---------------GUI-Abschnitt----------------------------------------------
import wx

class MyFrame(wx.Frame):
    """
    Die Klasse MyFrame erzeugt einen Frame fuer die Klasse Bruch.
    """
    def __init__(self, parent, title):
        wx.Frame.__init__(self, parent, -1, title,
                          pos=(100, 100), size=(350, 350))

        # Erzeugt die Komponente Menuezeile [menubar]
        menuBar = wx.MenuBar()
        # [noch zu klaeren: ist menuBar nur aus Faulheit als globale Variable definiert
        #  und nicht mit self. ???]

        # und erzeuge fuer die Menuezeile zwei Menuetitel.
        menu1 = wx.Menu()
        menu2 =wx.Menu()

        # Hier wird ein Menuepunkt in den ersten oben erzeugeten Menuetitel
        # eingefuegt. [add an item to the menu]
        # Mit \tKeyName wird ein Auswahlbuchstabe definiert, zudem auch automatisch
        # die Ereignisbehandlung generiert wird.
        # Der Text im dritten Parameter wird in der Statuszeile angezeigt.
        menu1.Append(wx.ID_EXIT, "B&eenden\tAlt-E", "Schliessen der Anwendung")

        # binde den Menuepunkt an seine Ereignisbehandlung [event handler]
        self.Bind(wx.EVT_MENU, self.OnTimeToClose, id=wx.ID_EXIT)

        # Fuege das Menue der Menuezeile hinzu.
        menuBar.Append(menu1, "&Datei")
        menuBar.Append(menu2, "&Hilfe")
        self.SetMenuBar(menuBar)
        # Anlegen der Statuszeile [z.B. fuer die oben definierten Meldungen]
        self.CreateStatusBar()
        

        # Erzeuge die Oberflaeche [wxPanel] fuer die hinzuzufuegenden Elemente.
        panel = wx.Panel(self)

        # Beschriftungen
        text = wx.StaticText(panel, -1, "Bruchrechnungsprogramm")
        text.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD))
        text.SetSize(text.GetBestSize())

        text2 = wx.StaticText(panel, -1, "Ergebnis :")
        text2.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD))
        text2.SetSize(text.GetBestSize())

        # Textfelder zur Eingabe und Ausgabe 
        self.textfeld1 = wx.TextCtrl(panel, -1, "11 / 20", size=(125, -1))
        self.textfeld2 = wx.TextCtrl(panel, -1, "7 / 8", size=(125, -1))
        self.textfeld3 = wx.TextCtrl(panel, -1, " ", size=(125, -1))

        # Buttons:
        # Ein Button auf der Oberflaeche zum Beenden der Anwendung ist immer hilfreich.
        endeBtn = wx.Button(panel, -1, "Beenden")
        endeBtn.SetToolTip("Button beendet die Anwendung")
        # je ein Button fuer jede Berechnung
        # Addition
        plusBtn = wx.Button(panel, -1, " + ")
        plusBtn.SetToolTip("addiert die beiden Brueche")
        
        # Subtraktion
        minusBtn = wx.Button(panel, -1, " - ")
        minusBtn.SetToolTip("subtrahiert die beiden Brueche")
        
        # Multiplikation
        malBtn = wx.Button(panel, -1, " * ")
        malBtn.SetToolTip("multipliziert die beiden Brueche")
        
        # Division
        durchBtn = wx.Button(panel, -1, " : ")
        durchBtn.SetToolTip("dividiert die beiden Brueche")
        
        # Verbinden der Ereignisbehandlung mit den Buttons [event-handler]
        self.Bind(wx.EVT_BUTTON, self.OnTimeToClose, endeBtn)
        self.Bind(wx.EVT_BUTTON, self.OnPlusButton, plusBtn)
        self.Bind(wx.EVT_BUTTON, self.OnMinusButton, minusBtn)
        self.Bind(wx.EVT_BUTTON, self.OnMalBtn, malBtn)
        self.Bind(wx.EVT_BUTTON, self.OnDurchBtn, durchBtn)
        
        

        # Hier wird ein Layoutmanager fuer ein tabellarisches Layout [GridSizer] verwendet.
        # Die Anzahl der Spalten wird auf 2 festgesetzt,
        # die 0 sorgt dafuer, das die Zahl der Zeilen automatisch festgelegt wird.
        sizer = wx.GridSizer(2, (0,0))
        # erste Zeile:
        sizer.Add(text, 0, wx.ALL, 10)
        sizer.Add(endeBtn, 0, wx.ALIGN_CENTER, 10)
        # zweite Zeile:
        sizer.Add(self.textfeld1, 0, wx.ALL, 10)
        sizer.Add(self.textfeld2, 0, wx.ALL, 10)
        # dritte Zeile:
        sizer.Add(plusBtn, 0, wx.ALL, 10)
        sizer.Add(minusBtn, 0, wx.ALL, 10)
        # vierte Zeile:
        sizer.Add(malBtn, 0, wx.ALL, 10)
        sizer.Add(durchBtn, 0, wx.ALL, 10)
        # fuenfte Zeile:
        sizer.Add(text2, 0, wx.ALL, 10)
        sizer.Add(self.textfeld3, 0, wx.ALL, 10)
        panel.SetSizer(sizer)
        panel.Layout()


    def OnTimeToClose(self, evt):
        """Ereignisbehandlung fuer den Ende-Button."""
        self.Close()

    def OnPlusButton(self, evt):
        """Ereignisbehandlung fuer den plus-Button."""
        b1, b2=self.holeBrueche()
        b=b1.addiere(b2)
        self.textfeld3.SetValue(b.gibString())
        
    def OnMinusButton(self, evt):
        """Ereignisbehandlung fuer den minus-Button."""
        b1, b2=self.holeBrueche()
        b=b1.subtrahiere(b2)
        self.textfeld3.SetValue(b.gibString())

    def OnMalBtn(self, evt):
        """Ereignisbehandlung fuer den minus-Button."""
        b1, b2=self.holeBrueche()
        b=b1.multipliziere(b2)
        self.textfeld3.SetValue(b.gibString())

    def OnDurchBtn(self, evt):
        """Ereignisbehandlung fuer den minus-Button."""
        b1, b2=self.holeBrueche()
        # Division durch 0 verhindern:
        if b2.zaehler!=0:
            b=b1.dividiere(b2)
            self.textfeld3.SetValue(b.gibString())
        else:
            self.textfeld3.SetValue("keine Division durch 0!")

        
        
    # Hilfsmethode zum Holen von Zaehler und Nenner
    def holeZahlen(self, text):
        text_teile=text.split()
        return int(text_teile[0]), int(text_teile[2])

    # Hilfsmethode zum Holen der Brueche
    def holeBrueche(self):
        z, n=self.holeZahlen(self.textfeld1.GetValue())
        b1=Bruch(z, n)
        z, n=self.holeZahlen(self.textfeld2.GetValue())
        b2=Bruch(z, n)
        return b1, b2
        



class MyApp(wx.App):
    def OnInit(self):
        frame = MyFrame(None, "Bruchrechnungs - Anwendung")
        self.SetTopWindow(frame)
        frame.Show(True)
        return True
        
app = MyApp(redirect=False)
app.MainLoop()

